#include <bits/stdc++.h>
#define ll long long
using namespace std;
int bit_width(ll x){
    for(int i=31;i>=0;i--){
        if(x&(1<<i)){
            return i;
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    ll n,q; cin>>n>>q;
    vector<ll> a(n);
    vector<vector<ll>> pref(32,vector<ll>(n));
    for(int i=0;i<n;i++) cin>>a[i];
    for(int i=0;i<n;i++){
        int bw=bit_width(a[i]);
        for(int j=0;j<32;j++){
            pref[j][i] =(i>0 ? pref[j][i-1] : 0)+(j==bw ? 1 : 0);
        }
    }
    while(q--){
        ll l,r;
        cin>>l>>r;
        l--,r--;
        ll maxi=1;
        for(int j=0;j<32;j++){
            ll cnt=pref[j][r]-(l>0 ? pref[j][l-1] : 0);
            maxi=max(maxi,cnt);
        }
        cout<<maxi<<"\n";
    }
    return 0;
}